function ret=gen_callback_frame(K,d)
  function my_callback_frame(ds,~)
    if isempty(ds)
      return;
    end
    nds=length(ds);
    hold on;
    for i=1:nds
      dsi=ds(i);
      [Rwc,twc]=pgKH2Rt(K,dsi.H,true);
      Xp=[0,0,0;1,0,0;0,1,0;0,0,1]';
      Up=pgProject(K,d,Rwc,twc,Xp);
      AprilTagFinder.drawLines(Up,[1,2;1,3;1,4],[1,0,0;0,1,0;0,0,1]);
    end
  end

ret=@my_callback_frame;
end