close all; clear all; clc;

% section 1. marker detection

%% run on image
!bin\AprilTagFinder.exe url=photo://data\masfm\00000.png tagfamiliesID=4
img=imread('data/masfm/00000.png');
thelog=cAprilTagFinderLog('AprilTagFinder_log_00000.m');
figure;
imshow(img);
AprilTagFinder.plot(thelog.tags);

%% run on camera
!bin\AprilTagFinder.exe url=camera://0 tagfamiliesID=4

%% run on camera and retrieve detections and images in matlab
% [ds,img]=run_apriltagfinder;
% figure;
% imshow(img);
% AprilTagFinder.plot(ds);

%% run on camera in matlab with callback functions
run_apriltagfinder_cb(@my_callback);